#!/bin/sh
#PostResults -*- TCL -*- Created: ramsan&miguel Jan-1997, Modified: ramsan Jan-1997


#----------------------PostResults ALONE---------------------------
# the next line restarts using wish \
	exec wish4.2 "$0" "$@"

set PRRunningAlone 0
# if { ![info exists GIDDEFAULT] } {
#     set PRRunningAlone 1
#     set tcl_interactive 0
#     set tk_strictMotif 1

#     if { [catch { set GIDDEFAULT $env(GIDDEFAULT)}]!=1 } {
#         set GIDDEFAULTTCL $GIDDEFAULT
#         catch { set GIDDEFAULTTCL $env(GIDDEFAULTTCL) }
#         set auto_path "$GIDDEFAULTTCL"
#         source $GIDDEFAULTTCL/init.tcl
#         source $GIDDEFAULTTCL/tk.tcl
#     }
#         wm withdraw .
# }

#  LOOK AT THE END OF THE FILE !!!
#-------------------------------------------------------------------

set PRDebug 0

proc PRToNode { node } {
    if { $::PRDebug} {
	WarnWinText "     ----> PRTONODE converting $node"
    }
    regsub -all {[^a-zA-Z0-9()_/-]} $node {_} node
    if { $::PRDebug} {
	WarnWinText "     ----> TO $node"
    }
    return $node
}

proc PRArbolNoResultado { arbol que_res} {
    global GidPriv

    set txt [_ "<No usable results found>"]
    if { $que_res == "No_Result"} {
	set txt [_ "<No result is drawn>"]
    } elseif { $que_res == "Contour_Ranges"} {
	set txt [_ "<No results with Result Range Table associated>"]
    }

    $arbol delete [ $arbol nodes root]
    $arbol insert end root "" -text $txt -data ""
    set GidPriv($arbol,cache) ""
}

proc PRConstruyeArbol { arbol lista_res} {
    global GidPriv

    if { $::PRDebug} {
	WarnWinText "PRconstruyeArbol $arbol $lista_res"
    }

    if { ![ info exist GidPriv($arbol,cache)]} {
	set GidPriv($arbol,cache) ""
    }

    # miramos si tenemos que recostruir el arbol
    if { $GidPriv($arbol,cache) != ""} {
	if { [ llength $lista_res] == [ llength $GidPriv($arbol,cache)]} {
	    set iguales 1
	    for { set i 0 } { $i < [ llength $lista_res]} { incr i} {
		if { ![ string equal [ lindex $lista_res $i] [ lindex $GidPriv($arbol,cache)]] } {
		    set iguales 0
		    break
		}
	    }
	    if { $iguales} { return}
	}
    }
    $arbol delete [ $arbol nodes root]

    #trad#
    #regsub -all { } $GidPriv(PostResultsView) {_} res_view
    if { ![ info exists GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))]} {
	PrInitTablaTrad
	if { $::PRDebug} {
	    WarnWinText "PRConstruyeArbol no existe GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))"
	}
	if { ![ info exists GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))]} {
	    if { $::PRDebug} {
		WarnWinText "PRConstruyeArbol vuelve a no existir GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))"
	    }
	    return
	}
    }
    set res_view $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))
    regsub -all { } $GidPriv(PostResultsAnal) {_} res_anal
    set res_step $GidPriv(PostResultsStep)

    if { $::PRDebug} {
	WarnWinText "   arbol delete"
    }
    $arbol delete [ $arbol nodes root]
    
    #set l_res [ lsort $lista_res]
    set l_res $lista_res

    foreach i_res $l_res {
	if { ![ regexp {^/?/?(.*)//(.*?)$} $i_res dum path res_name]} {
	    set path root
	    set res_name $i_res
	}
	set pp ""
	regsub -all {//} $path { } lst_niveles
	foreach iniv $lst_niveles {
	    set padre $pp
	    if { "$pp" != ""} { append pp //} else { set padre root}
	    append pp $iniv
	    regsub -all {_} $iniv { } txt
	    set pp [PRToNode $pp]
	    if { ![ $arbol exists $pp] } {
		if { $::PRDebug} {
		    WarnWinText "   1:arbol insert end $padre $pp -text $txt -image {GetImage folder.gif} -data nodo"
		}
		$arbol insert end $padre $pp -text $txt -image [GetImage folder.gif] -data nodo
	    }
	}
	regsub -all {_} $res_name { } txt
	#$arbol insert end $path "$path->$res_name" -text $txt -image [GetImage point16x16.gif]
	set l_comp [ .central.s info post get components_list $res_view $i_res $res_anal $res_step]
	set n_comp [ llength $l_comp]
	if { $n_comp > 1} {
	    if { $::PRDebug} {
		WarnWinText "   2:arbol [ PRToNode $path] [PRToNode $i_res] -text $txt -data nodoinsert end"
	    }
	    $arbol insert end [ PRToNode $path] [ PRToNode $i_res] -text $txt -image [GetImage prof1.gif] -data nodo
	    foreach comp [ .central.s info post get components_list $res_view $i_res $res_anal $res_step] {
		regsub -all {_} $comp { } txt
		if { $::PRDebug} {
		    WarnWinText "   3:arbol insert end [PRToNode $i_res] [PRToNode \"$i_res->$comp\"] -text $txt -image {GetImage point16x16.gif]} -data [ list hoja $i_res $comp]"
		}
		$arbol insert end [PRToNode $i_res] [PRToNode "$i_res->$comp"] \
		    -text $txt -image [GetImage point16x16.gif] \
		    -data [ list hoja $i_res $comp]
	    }
	} else {
	    regsub -all {_} $l_comp { } txt
	    if { $::PRDebug} {
		WarnWinText "   4:arbol insert end [ PRToNode $path] [PRToNode \"$i_res->$l_comp\"] -text $txt -image { GetImage point16x16.gif} -data [ list hoja $i_res $l_comp]"
	    }
	    $arbol insert end [ PRToNode $path] [PRToNode "$i_res->$l_comp"] \
		-text $txt -image [GetImage point16x16.gif] \
		-data [ list hoja $i_res $l_comp]
	}
    }
    if { $::PRDebug} {
	WarnWinText "     done."
    }
}

proc PrInitTablaTrad {} {
    global GidPriv

    set all [ .central.s info post get all_results_views]

    # para las traducciones:
    # i para que me los coja el buscador de cadenas de traduccin:
    # [_ "No Result"]
    # [_ "Display Vectors"]
    # [_ "Contour Fill"]
    # [_ "Smooth Contour Fill"]
    # [_ "Contour Lines"]
    # [_ "Contour Ranges"]
    # [_ "Sh Min Max"]
    # [_ "Show Min Max"]
    # [_ "Result Surface"]
    # [_ "Scalar Line Diagram"]
    # [_ "Vector Line Diagram"]
    #trad#
    foreach j $all {
	regsub -all {_} $j { } txt
	set trad [_ $txt]
	set GidPriv(PostResultsViewTrad,$j) $trad
	set GidPriv(PostResultsViewOrig,$trad) $j
	if { $::PRDebug} {
	    WarnWinText "$trad <-> $j"
	}
    }
}

proc FillPRInfo {} {
    global GidPriv

    if { $::PRDebug} {
	WarnWinText FillPRInfo----------------------------
    }

    if { ![info exists GidPriv(PostResultsWindow)] || \
	    ![winfo exists $GidPriv(PostResultsWindow)] } { return }

    if { ![ info exists GidPriv(PRDoingAccept)]} {        
	set GidPriv(PRDoingAccept) 0
    }

    if { $GidPriv(PRDoingAccept)} { return}

    set w $GidPriv(PostResultsWindow)

    if { $::PRDebug} {
	WarnWinText "FillPRInfo: getting info"
    }
    set all [lsort -dictionary [.central.s info post get all_analisis]]
    # set all [ .central.s info post get all_analisis]
    set curr [.central.s info post get cur_analisis]
    if { $all == ""} { 
	if { $::PRDebug} {
	    WarnWinText "FillPRInfo: no analysis found."
	}
	#$w.rv.m1.menu del 0 end
	#$w.rv.m2.menu del 0 end
	$w.rv.m1 configure -values ""
	$w.rv.m2 configure -values ""
	#$w.rv.m3.menu del 0 end
	$GidPriv(Result_wid) delete [ $GidPriv(Result_wid) nodes root]
	set GidPriv($GidPriv(Result_wid),cache) ""
	$w.rv.m3 listbox del 0 end
	$w.rv.m4.menu del 0 end
	return
    }

    PostResultsDeleteTraceVariables $GidPriv(PostResultsWindow) $GidPriv(PostResultsWindow)

    #$w.rv.m1.menu del 0 end
    set max_len 0
    $w.rv.m1 configure -values ""
    #foreach i $all {
    #         regsub -all {_} $i { } var
    #         $w.rv.m1.menu add command -label $var -command \
    #                 [list set GidPriv(PostResultsAnal) $var]
    #}
    set all_analisis {}
    foreach i $all {
	regsub -all {_} $i { } var
	lappend all_analisis $var
	set l [ string length $var]
	if { $l > $max_len} {
	    set max_len $l
	}
    }
    $w.rv.m1 configure -values $all_analisis
    if { $l > 20} {
	grid configure $w.rv.m1 -sticky ew
    }
    if { $curr != "" } {
	regsub -all {_} $curr { } curr
    } else { regsub -all {_} [lindex $all 0] { } curr }
    if { $::PRDebug} {
	WarnWinText "FillPRInfo: set GidPriv(PostResultsAnal) -$curr-"
    }
    set GidPriv(PostResultsAnal) $curr
    if { $::PRDebug} {
	WarnWinText "FillPRInfo: done"
    }

    # Ahora los Steps:
    regsub -all { } $GidPriv(PostResultsAnal) {_} analisis
    if { $analisis != ""} {
	set current [ .central.s info post get cur_step $analisis]
	set currentidx 0
	set all_steps [ .central.s info post get all_steps $analisis]
	set mxw 0
	foreach st $all_steps {
	    if { [ string length $st] > $mxw} {
		set mxw [ string length $st]
	    }
	}
	if { $mxw < 6} { set mxw 6}
	$w.rv.cbstep configure -values $all_steps -width $mxw
	set GidPriv(PostResultsStep) $current
    } else {
	$w.rv.cbstep configure -values ""
    }
    set all [ .central.s info post get all_steps $analisis]
    set curr [ .central.s info post get cur_step]
    if { $curr != "" } {
	regsub -all {_} $curr { } curr
    } else { regsub -all {_} [lindex $all 0] { } curr }
    if { $::PRDebug} {
	WarnWinText "FillPRInfo: set GidPriv(PostResultsStep) -$curr-"
    }
    set GidPriv(PostResultsStep) $curr
    if { $::PRDebug} {
	WarnWinText "FillPRInfo: done"
    }


    # Ahora la vista de resultados
    #$w.rv.m2.menu del 0 end
    $w.rv.m2 configure -values ""
    set all [ .central.s info post get all_results_views]

    # para las traducciones:
    # i para que me los coja el buscador de cadenas de traduccin:
    # [_ "No Result"]
    # [_ "Display Vectors"]
    # [_ "Contour Fill"]
    # [_ "Smooth Contour Fill"]
    # [_ "Contour Lines"]
    # [_ "Contour Ranges"]
    # [_ "Sh Min Max"]
    # [_ "Show Min Max"]
    # [_ "Result Surface"]
    # [_ "Scalar Line Diagram"]
    # [_ "Vector Line Diagram"]
    #trad#

    PrInitTablaTrad

    # foreach j $all {
    # 	regsub -all {_} $j { } txt
    # 	set trad [_ $txt]
    # 	set GidPriv(PostResultsViewTrad,$j) $trad
    # 	set GidPriv(PostResultsViewOrig,$trad) $j
    # 	if { $::PRDebug} {
    # 	    WarnWinText "$trad <-> $j"
    # 	}
    # }

    set all_views {}
    foreach j $all {
	regsub -all {_} $j { } var
	#$w.rv.m2.menu add command -label $var -command \
	#        [list set GidPriv(PostResultsView) $var]

	#lappend all_views $var
	#trad#
	lappend all_views $GidPriv(PostResultsViewTrad,$j)
    }
    $w.rv.m2 configure -values $all_views
    set curr [ .central.s info post get cur_results_view]
    if { $curr == "Iso_Surfaces"} { set curr "No_Result"}
    #trad#
    #if { $curr == "" } {
    #         regsub -all {_} [ lindex $all 0] { } curr
    #} else {
    #         regsub -all {_} $curr { } curr
    #}
    if { $curr == "" } {
	    set curr [ lindex $all 0]
    }
    #trad#
    #set GidPriv(PostResultsView) $curr
    set GidPriv(PostResultsView) $GidPriv(PostResultsViewTrad,$curr)

    # Ahora los resultados
    #$w.rv.m3.menu del 0 end
    #$GidPriv(Result_wid) delete [ $GidPriv(Result_wid) nodes root]
    $w.rv.m3 listbox del 0 end
    #trad#
    #regsub -all { }  $GidPriv(PostResultsView) {_} curr
    set all [ .central.s info post get cur_results_list $curr ]
    
    set all [ lsort $all]

    if { $all != "" } {
	
	PRConstruyeArbol $GidPriv(Result_wid) $all

	foreach j $all {
	    regsub -all {_} $j { } var
	    #$w.rv.m3.menu add command -label $var -command \
		#    [list set GidPriv(PostResultsRes) $var]
	    $w.rv.m3 add $var
	}

	set curr [ .central.s info post get cur_result]
	if { $curr == "" } {
	    regsub -all {_} [ lindex $all 0] { } curr
	} else {
	    regsub -all {_} $curr { } curr
	}

	set GidPriv(PostResultsRes) $curr
    } else {
	set GidPriv(PostResultsRes) ""
	#trad#
	#PRArbolNoResultado $GidPriv(Result_wid) $GidPriv(PostResultsView)
	PRArbolNoResultado $GidPriv(Result_wid) $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))
    }

    # y sus compoenentes
    $w.rv.m4.menu del 0 end
    if { $GidPriv(PostResultsRes) != "" } {
	regsub -all { } $GidPriv(PostResultsRes) {_} curr
	set all [ .central.s info post get cur_components_list $curr ]
	if { $all != "" } {
	    foreach j $all {
		regsub -all {_} $j { } var
		$w.rv.m4.menu add command -label $var -command \
		        [list set GidPriv(PostResultsComp) $var]
	    }
	    
	    set curr [ .central.s info post get cur_component]
	    if { $curr == "" } {
		regsub -all {_} [ lindex $all 0] { } curr
	    } else {
		regsub -all {_} $curr { } curr
	    }

	    set GidPriv(PostResultsComp) $curr
	}
    } else {
	set GidPriv(PostResultsComp) ""
    }

    if { ( "$GidPriv(PostResultsRes)" != "") && ( "$GidPriv(PostResultsComp)" != "")} {
	set nodo "$GidPriv(PostResultsRes)->$GidPriv(PostResultsComp)"
	regsub -all { } $nodo {_} nodo
	set nodo [PRToNode $nodo]
	set arbol $GidPriv(Result_wid)
	if { $::PRDebug} {
	    WarnWinText "     1:arbol selection set $nodo"
	}
	$arbol selection set $nodo
	for { set p $nodo} { "$p" != "root"} { set p [ $arbol parent $p]} {
	    if { $::PRDebug} {
		WarnWinText "     1:arbol opentree $p"
	    }
	    $arbol opentree $p
	}
    }

    #trad#
    set orig $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))
    if { ( $orig != "Display_Vectors") && \
	    ( $orig != "Result_Surface") && \
	    ( $orig != "Scalar_Line_Diagram") && \
	    ( $orig != "Vector_Line_Diagram") } {
	#$w.rv.f.e2 del 0 end 
	$w.rv.f.e2 configure -foreground grey60
	$w.rv.f.e2 configure -state disabled
	$w.rv.f.l6 configure -foreground grey60
    }

    PostResultsSetTraceVariables

}

proc FillPRSteps {name1 name2 op} {
    global GidPriv

    if { $::PRDebug} {
	WarnWinText "FillPRSteps---------------------- $name1 $name2"
    }
    set w $GidPriv(PostResultsWindow)
    regsub -all { } $GidPriv(PostResultsAnal) {_} analisis
    if { $::PRDebug} {
	WarnWinText "FillPRSteps: analisis = '$analisis'"
    }
    if { $analisis != ""} {
	set all [ .central.s info post get all_steps $analisis]
	set current [ .central.s info post get cur_step $analisis]
	if { ( $current == "") || ( [ lsearch $all $current] == -1) } { 
	    regsub -all {_} [lindex $all 0] { } current
	}
	set mxw 0
	foreach st $all {
	    if { [ string length $st] > $mxw} {
		set mxw [ string length $st]
	    }
	}
	if { $mxw < 6} { set mxw 6}
	$w.rv.cbstep configure -values $all -width $mxw
	if { $::PRDebug} {
	    WarnWinText "FillPRSteps: set GidPriv(PostResultsStep) -$current-"
	}
	set GidPriv(PostResultsStep) $current
    } else {
	$w.rv.cbstep configure -values ""
	$w.rv.cbstep configure -state disabled
    }
}

proc PRChangedStep {name1 name2 op} {
    global GidPriv
    set w $GidPriv(PostResultsWindow)

    if {  $GidPriv(PostResultsStep) == ""} { return }
    FillPROtherMenusLazy $name1 $name2 $op
    return
}

proc FillPROtherMenus {name1 name2 op} {
    global GidPriv
    set w $GidPriv(PostResultsWindow)

    #puts FillPROtherMenus-----------------------------
    if { $::PRDebug} {
	WarnWinText "FillPROtherMenus----------------- $name1 $name2 $op"
    }
    set vn { PostResultsStep PostResultsView PostResultsRes PostResultsComp}
    set allmenus "$w.rv.m2 $w.rv.m3 $w.rv.m4.menu"
    set i [lsearch $vn $name2]

    # como se usa en varios sitios, lo verifico aqui
    if { ![ info exists GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))]} {
	PrInitTablaTrad
	if { $::PRDebug} {
	    WarnWinText "FillPROtherMenus no existe GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))"
	}
	if { ![ info exists GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))]} {
	    if { $::PRDebug} {
		WarnWinText "FillPROtherMenus vuelve a no existir GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))"
	    }
	    return
	}
    }

    switch $i {
	0 {
	    set all [ .central.s info post get all_results_views]
	    set curr [ .central.s info post get cur_results_view]
	    if { $curr == "Iso_Surfaces"} { set curr "No_Result"}
	}
	1 {
	    if { $::PRDebug} {
		WarnWinText "1 FillPROtherMenus: $GidPriv(PostResultsView)"
	    }
	    if { $GidPriv(PostResultsView) == "" } {
		set all ""
		set curr ""
	    } else {
		#trad#
		#regsub -all { } $GidPriv(PostResultsView) {_} res_view
#catch {
		set res_view $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))
#} pp
		if { $::PRDebug} {
		    #WarnWinText "catch -> $pp"
		    WarnWinText "----> trad $res_view"
		}
		regsub -all { } $GidPriv(PostResultsAnal) {_} res_anal
		if { $::PRDebug} {
		    WarnWinText "----> trad $res_anal"
		}
		if { ( $res_view == "" ) || ( $res_anal == "") } {
		    set all ""
		    set curr ""
		} else {
		    
		    set all [ .central.s info post get results_list \
		            $res_view  $res_anal \
		            $GidPriv(PostResultsStep)]

		    set all [ lsort $all]

		    if { $::PRDebug} {
		        WarnWinText "$res_view -> $all"
		    }
		    
		    set curr [ .central.s info post get cur_result]
		    if { $curr == "" || [ lsearch -exact $all $curr] == -1 } {
		        set curr [lindex $all 0]
		    }
		    regsub -all { } $GidPriv(PostResultsRes) {_} res_res
		    regsub -all { } $GidPriv(PostResultsComp) {_} res_comp
		    if { [ lsearch -exact $all $res_res] == -1} {
		        set res_res [ lindex $all 0]
		        set all_comp [ .central.s info post get components_list $res_view $res_res $res_anal $GidPriv(PostResultsStep)]
		        set res_comp [ lindex $all_comp 0]
		    }
		    if { $res_view == "Display_Vectors" } {
		        $w.rv.f.e2 configure -state normal
		        $w.rv.f.e2 configure -foreground black
		        $w.rv.f.l6 configure -foreground black
		        if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		                ( $GidPriv(PostResultsStep) != "") } {
		            #WarnWin "1 - -$res_view-$res_res-$res_anal-$GidPriv(PostResultsStep)-"
		            set kk  [ .central.s info post get cur_vector_factor \
		                    $res_view $res_res $res_anal $GidPriv(PostResultsStep) ]
		            if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		                set kk $GidPriv(PostResultsVfact)
		            }
		            #set ec "[ $w.rv.f.e2 get]"
		            if { $::PRDebug} {
		                WarnWinText "1: -$kk-$ec-$GidPriv(PostResultsVfact)"
		            }
		            #if { ( "$GidPriv(PostResultsVfact)" != "") && ( "$ec" != "") && \
		            #             ( $kk != 0) && \
		            #             [ expr ( $kk != $GidPriv(PostResultsVfact)) && ( $kk != $ec)] } 
		            if { $kk != 0} {
		                $w.rv.f.e2 del 0 end
		                $w.rv.f.e2 ins end $kk 
		                if { $::PRDebug} {
		                    WarnWinText "      entry = [ $w.rv.f.e2 get]"
		                }
		            }
		            focus $w.rv.f.e2
		        } else { 
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		            focus $w.rv.f.e2
		        }
		        $w.rv.m4 configure -state normal
		    } elseif { ( $res_view == "Scalar_Line_Diagram") || \
		            ( $res_view == "Vector_Line_Diagram") } {
		        $w.rv.f.e2 configure -state normal
		        $w.rv.f.e2 configure -foreground black
		        $w.rv.f.e2 del 0 end
		        $w.rv.f.l6 configure -foreground black
		        if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		                ( $GidPriv(PostResultsStep) != "") } {
		            if { ( $res_view == "Scalar_Line_Diagram") && ( $res_comp != "")} {
		                set kk  [ .central.s info post get cur_diagram_factor $res_res $res_comp $res_anal $GidPriv(PostResultsStep)]
		            } else {
		                set kk  [ .central.s info post get cur_diagram_factor $res_res $res_anal $GidPriv(PostResultsStep)]
		            }
		            if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		                set kk $GidPriv(PostResultsVfact)
		            }
		            if { $kk != 0 } {
		                $w.rv.f.e2 del 0 end 
		                $w.rv.f.e2 ins end $kk 
		            }
		            focus $w.rv.f.e2
		        } else { 
		            $w.rv.f.e2 ins end "1.0"
		            focus $w.rv.f.e2
		        }
		        if { $res_view == "Vector_Line_Diagram" } {
		            $w.rv.m4 configure -state disabled
		        } else {
		            $w.rv.m4 configure -state normal
		        }
		    } elseif { $res_view == "Result_Surface" } {
		        $w.rv.f.e2 configure -state normal
		        $w.rv.f.e2 configure -foreground black
		        $w.rv.f.e2 del 0 end
		        $w.rv.f.l6 configure -foreground black
		        if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		                ( $GidPriv(PostResultsStep) != "") } {
		            if { $::PRDebug} {
		                WarnWinText "1 - -$res_view-$res_res-$res_comp-$res_anal-$GidPriv(PostResultsStep)-"
		            }
		            set kk  [ .central.s info post get cur_result_surface_factor \
		                    $res_view $res_res $res_comp $res_anal $GidPriv(PostResultsStep) ]
		            if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		                set kk $GidPriv(PostResultsVfact)
		            }
		            if { $kk != 0 } { 
		                $w.rv.f.e2 del 0 end
		                $w.rv.f.e2 ins end $kk 
		            }
		            focus $w.rv.f.e2
		        } else { 
		            $w.rv.f.e2 ins end "1.0"
		            focus $w.rv.f.e2
		        }
		        $w.rv.m4 configure -state normal
		    } else { 
		        #$w.rv.f.e2 del 0 end 
		        $w.rv.f.e2 configure -foreground grey60
		        $w.rv.f.e2 configure -state disabled
		        $w.rv.f.l6 configure -foreground grey60
		        $w.rv.m4 configure -state normal
		    }
		}
	    }
	}
	2 {
	    if { $GidPriv(PostResultsView) == "" } {
		set all ""
		set curr ""
	    } else {
		#trad#
		#regsub -all { } $GidPriv(PostResultsView) {_} res_view
		set res_view $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))
		regsub -all { } $GidPriv(PostResultsRes) {_} res_res
		regsub -all { } $GidPriv(PostResultsAnal) {_} res_anal
		set all [ .central.s info post get components_list \
		        $res_view $res_res $res_anal \
		        $GidPriv(PostResultsStep)]
		set curr [ .central.s info post get cur_component]
		if { $curr == "" || [ lsearch -exact $all $curr] == -1 } {
		    set curr [lindex $all 0]
		}
		if { $res_view == "Display_Vectors" } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		        if { $::PRDebug} {
		            WarnWinText "2 --$res_view-$res_res-$curr-$res_anal-$GidPriv(PostResultsStep)-"
		        }
		        set kk  [ .central.s info post get cur_vector_factor \
		                $res_view $res_res $curr $res_anal $GidPriv(PostResultsStep) ]
		        if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        #set ec "[ $w.rv.f.e2 get]"
		        if { $::PRDebug} {
		            WarnWinText "2: -$kk-$ec-$GidPriv(PostResultsVfact)"
		        }
		        #if { ( "$GidPriv(PostResultsVfact)" != "") && ( "$ec" != "") && \
		          #             ( $kk != 0) && \
		        #             [ expr ( $kk != $GidPriv(PostResultsVfact)) && ( $kk != $ec)] } 
		        if { $kk != 0} {
		            $w.rv.f.e2 del 0 end  
		            $w.rv.f.e2 ins end $kk 
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		        }
		    }
		}
		if { ( $res_view == "Scalar_Line_Diagram") || \
		        ( $res_view == "Vector_Line_Diagram") } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		        if { ( $res_view == "Scalar_Line_Diagram") && ( $curr != "")} {
		            set kk  [ .central.s info post get cur_diagram_factor $res_res $curr $res_anal $GidPriv(PostResultsStep)]
		        } else {
		            set kk  [ .central.s info post get cur_diagram_factor $res_res $res_anal $GidPriv(PostResultsStep)]
		        }
		        #WarnWin "'$res_res' '$curr' '$res_anal' '$GidPriv(PostResultsStep)' -> '$kk'"
		        if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $kk != 0 } { 
		            $w.rv.f.e2 del 0 end  
		            $w.rv.f.e2 ins end $kk 
		        }
		    } else { 
		        $w.rv.f.e2 del 0 end
		        $w.rv.f.e2 ins end "1.0"
		    }
		}
		if { $res_view == "Result_Surface" } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		        if { $::PRDebug} {
		            WarnWinText "2 --$res_view-$res_res-$curr-$res_anal-$GidPriv(PostResultsStep)-$GidPriv(PostResultsComp)"
		        }
		        set kk  [ .central.s info post get cur_result_surface_factor \
		                $res_view $res_res $curr $res_anal $GidPriv(PostResultsStep) ]
		        if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $kk != 0 } {
		            $w.rv.f.e2 del 0 end  
		            $w.rv.f.e2 ins end $kk 
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		        }
		    }
		}
	    }
	}
	3 {
	    if { $GidPriv(PostResultsView) == "" } {
		set all ""
		set curr ""
	    } else {
		#trad#
		#regsub -all { } $GidPriv(PostResultsView) {_} res_view
		set res_view $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))
		regsub -all { } $GidPriv(PostResultsRes) {_} res_res
		regsub -all { } $GidPriv(PostResultsComp) {_} res_comp
		regsub -all { } $GidPriv(PostResultsAnal) {_} res_anal
		set all [ .central.s info post get components_list \
		        $res_view $res_res $res_anal \
		        $GidPriv(PostResultsStep)]
		set curr [ .central.s info post get cur_component]
		if { $curr == "" || [ lsearch -exact $all $curr] == -1 } {
		    set curr [lindex $all 0]
		}
		if { $res_view == "Display_Vectors" } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		        #WarnWin "3 -$res_view-$res_res-$res_comp-$res_anal-$GidPriv(PostResultsStep)-"
		        set kk  [ .central.s info post get cur_vector_factor \
		                $res_view $res_res $res_comp $res_anal $GidPriv(PostResultsStep) ]
		        if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        #set ec "[ $w.rv.f.e2 get]"
		        if { $::PRDebug} {
		            WarnWinText "3: -$kk-$ec-$GidPriv(PostResultsVfact)"
		        }
		        #if { ( "$GidPriv(PostResultsVfact)" != "") && ( "$ec" != "") && \
		          #             ( $kk != 0) && \
		        #             [ expr ( $kk != $GidPriv(PostResultsVfact)) && ( $kk != $ec)] } 
		        if { $kk != 0} {
		            $w.rv.f.e2 del 0 end  
		            $w.rv.f.e2 ins end $kk 
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		        }
		    }
		}
		if { ( $res_view == "Scalar_Line_Diagram") || \
		        ( $res_view == "Vector_Line_Diagram") } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		        if { ( $res_view == "Scalar_Line_Diagram") && ( $res_comp != "")} {
		            set kk  [ .central.s info post get cur_diagram_factor $res_res $res_comp $res_anal $GidPriv(PostResultsStep)]
		        } else {
		            set kk  [ .central.s info post get cur_diagram_factor $res_res $res_anal $GidPriv(PostResultsStep)]
		        }
		        #WarnWin "'$res_res' '$res_comp' '$res_anal' '$GidPriv(PostResultsStep)' -> '$kk'"
		        if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $kk != 0 } { 
		            $w.rv.f.e2 del 0 end  
		            $w.rv.f.e2 ins end $kk 
		        }
		    } else { 
		        $w.rv.f.e2 del 0 end
		        $w.rv.f.e2 ins end "1.0"
		    }
		}
		if { $res_view == "Result_Surface" } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		        #WarnWin "3 -$res_view-$res_res-$res_comp-$res_anal-$GidPriv(PostResultsStep)-"
		        set kk  [ .central.s info post get cur_result_surface_factor \
		                $res_view $res_res $res_comp $res_anal $GidPriv(PostResultsStep) ]
		        if { ( "$GidPriv(PostResultsVfact)" != "") && [ expr $kk == $GidPriv(PostResultsVfact)]} {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $kk != 0 } {
		            $w.rv.f.e2 del 0 end  
		            $w.rv.f.e2 ins end $kk 
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		        }
		    }
		}
	    }
	}
    }

    if { "[lindex $vn [expr $i+1]]" != ""} {
	if { $::PRDebug} {
	    WarnWinText "[lindex $vn [expr $i+1]] - $curr - $GidPriv([lindex $vn [expr $i+1]])"
	}
	#if { $GidPriv([lindex $vn [expr $i+1]]) != $curr } {
	    set m [lindex $allmenus $i]
	    if { "$m" == "$w.rv.m2"} {
		if { $::PRDebug} {
		    WarnWinText "Contruyendo $m -> $all"
		}
		#$m del 0 end
		$m configure -values ""
		set lst_val {}
		foreach j $all {
		    regsub -all {_} $j { } var
		    #$m add command -label $var -command \
		        #    [list set GidPriv([lindex $vn [expr $i+1]]) $var]
		    lappend lst_val $var
		}
		$m configure -values $lst_val
	    } elseif { "$m" == "$w.rv.m3"} {
		if { $::PRDebug} {
		    WarnWinText "Contruyendo arbol $m -> $all"
		}
		#$GidPriv(Result_wid) delete [ $GidPriv(Result_wid) nodes root]

		if { $all != ""} {
		    PRConstruyeArbol $GidPriv(Result_wid) $all
		} else {
		    #trad#
		    # PRArbolNoResultado $GidPriv(Result_wid) $GidPriv(PostResultsView)
		    set res_view $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))
		    PRArbolNoResultado $GidPriv(Result_wid) $res_view
		}

		$m listbox del 0 end
		foreach j $all {
		    regsub -all {_} $j { } var
		    $m add $var
		}
	    } else {
		if { $::PRDebug} {
		    WarnWinText "Contruyendo resto $m -> $all"
		}
		$m del 0 end
		foreach j $all {
		    regsub -all {_} $j { } var
		    $m add command -label $var -command \
		            [list set GidPriv([lindex $vn [expr $i+1]]) $var]
		}
	    }
	if { $::PRDebug} {
	    WarnWinText "construyendo -> done"
	}
	    if { [ string equal [lindex $vn [expr $i+1]] PostResultsView]} {
		set curr $GidPriv(PostResultsViewTrad,$curr)
	    } else {
		regsub -all {_} $curr { } curr
	    }
	if { $::PRDebug} {
	    WarnWinText "set GidPriv([lindex $vn [expr $i+1]]) $curr"
	}
	    set GidPriv([lindex $vn [expr $i+1]]) $curr

	    if { $GidPriv(Result_actualizar)  && \
		    ( "$GidPriv(PostResultsRes)" != "") && ( "$GidPriv(PostResultsComp)" != "")} {
		set nodo "$GidPriv(PostResultsRes)->$GidPriv(PostResultsComp)"
		regsub -all { } $nodo {_} nodo
		catch {
		    set arbol $GidPriv(Result_wid)
		    if { $::PRDebug} {
			WarnWinText "     2:arbol selection set $nodo"
		    }
		    $arbol selection set $nodo
		    for { set p $nodo} { "$p" != "root"} { set p [ $arbol parent $p]} {
			if { $::PRDebug} {
			    WarnWinText "     2:arbol opentree $p"
			}
		        $arbol opentree $p
		    }
		}
	    }

	#}
    }
}

proc FillPROtherMenusLazy { name1 name2 op} {
    global GidPriv
    set w $GidPriv(PostResultsWindow)

    #puts FillPROtherMenusLazy---------------------------------
    #trad#
    #regsub -all { } $GidPriv(PostResultsView) {_} res_view
    if { $::PRDebug} {
	WarnWinText "FillPROtherMenusLazy------------- $name1 $name2 $op"
    }

    if { ![ info exists GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))]} {
	PrInitTablaTrad
	if { $::PRDebug} {
	    WarnWinText "FillPROtherMenusLazy no existe GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))"
	}
	if { ![ info exists GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))]} {
	    if { $::PRDebug} {
		WarnWinText "FillPrOtherMenusLazy vuelve a no existir GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))"
	    }
	    return
	}
    }
    
    set res_view $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))
    regsub -all { } $GidPriv(PostResultsAnal) {_} res_anal
    if { $::PRDebug} {
	WarnWinText "Lazy 1: '$res_view' $res_anal"
    }
    if { $res_view == "" } {
	FillPROtherMenus $name1 $name2 $op 
	return
    }

    set all [ .central.s info post get results_list $res_view $res_anal \
	    $GidPriv(PostResultsStep) ]
    regsub -all { } $GidPriv(PostResultsRes) {_} res_res

    if { $::PRDebug} {
	WarnWinText "Lazy 2: $res_view $res_anal $GidPriv(PostResultsStep) '$res_res'"
    }
    if { $res_res == "" } {
	FillPROtherMenus $name1 $name2 $op 
	return
    }
    if { [ lsearch $all $res_res] == -1 } { 
	if { $::PRDebug} {
	    WarnWinText "Lazy 3: $res_view $res_anal $GidPriv(PostResultsStep) $res_res"
	}
	# FillPROtherMenus $name1 $name2 $op
	# decimos que queremos otra vez el c.fill para que nos escoja el primero de la lista
	FillPROtherMenus GidPriv PostResultsView $op
	return
    } else {
	set all [ .central.s info post get components_list $res_view \
		$res_res $res_anal $GidPriv(PostResultsStep)]
	regsub -all { } $GidPriv(PostResultsComp) {_} res_comp
	if { $::PRDebug} {
	    WarnWinText "Lazy 4: $res_view $res_anal $GidPriv(PostResultsStep) $res_res $res_comp"
	}
	if { [ lsearch $all $res_comp] == -1 } { 
	    if { $::PRDebug} {
		WarnWinText "Lazy 5: $res_view $res_anal $GidPriv(PostResultsStep) $res_res $res_comp"
	    }
	    #FillPROtherMenus $name1 $name2 $op 
	    # decimos que queremos otra vez el c.fill para que nos escoja el primero de la lista
	    FillPROtherMenus GidPriv PostResultsView $op
	    return
	} 
    }
}

proc PRAccept {} {
    global GidPriv
    
    if { ![ info exists GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))]} {
	PrInitTablaTrad
	if { $::PRDebug} {
	    WarnWinText "PRConstruyeArbol no existe GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))"
	}
	if { ![ info exists GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))]} {
	    if { $::PRDebug} {
		WarnWinText "PRConstruyeArbol vuelve a no existir GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView))"
	    }
	    return
	}
    }

    regsub -all {_} $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView)) {} res_view
    set quitar_resultado 0
    if { [ string equal -nocase $res_view NoResult]} {
	set quitar_resultado 1
    }
    if { !$quitar_resultado && ( [$GidPriv(Result_wid) selection get] == "")} { return}
    set w $GidPriv(PostResultsWindow)

    set GidPriv(PRDoingAccept) 1
    if { !$quitar_resultado} {
	set entry_fact $GidPriv(PostResultsVfact)
	PRSeleccionResultado [$GidPriv(Result_wid) selection get]
	set GidPriv(PostResultsVfact) $entry_fact
    }

    #puts PRAccept---------------------------
    set oldAutomaticRedraw [ .central.s info variables AutomaticRedraw]
    .central.s process escape escape escape escape escape escape utilities variables \
	    AutomaticRedraw -1 escape escape escape escape 

    regsub -all { } $GidPriv(PostResultsAnal) {_} res_anal
    regsub -all { } $GidPriv(PostResultsStep) {_} res_step
    set postcmd "escape escape escape escape escape escape results analysissel $res_anal $res_step"
    #trad#
    #regsub -all { } $GidPriv(PostResultsView) {} res_view
    regsub -all {_} $GidPriv(PostResultsViewOrig,$GidPriv(PostResultsView)) {} res_view
    if { $res_view == "NoResult"} {
	set postcmd "$postcmd geometry $res_view"
    } else {
	regsub -all { } $GidPriv(PostResultsRes) {_} res_res
	regsub -all { } $GidPriv(PostResultsComp) {_} res_comp
	if { ( $res_view != "ScalarLineDiagram") && \
		( $res_view != "VectorLineDiagram") } {
	    set postcmd "$postcmd $res_view"
	    set postcmd "$postcmd $res_res"
	    set postcmd "$postcmd $res_comp"
	    if { $res_view == "DisplayVectors" } {
		if { $GidPriv(PostResultsVfact) != ""} {
		    set postcmd "$postcmd $GidPriv(PostResultsVfact)"
		}
	    }
	    if { $res_view == "ResultSurface" } {
		if { $GidPriv(PostResultsVfact) != ""} {
		    set postcmd "$postcmd $GidPriv(PostResultsVfact)"
		}
	    }
	} else {
	    if { $res_view == "ScalarLineDiagram"} {
		set postcmd "$postcmd linediagram scalardiagram $res_res $res_comp $GidPriv(PostResultsVfact)"
	    } else {
		set postcmd "$postcmd linediagram vectordiagram $res_res $GidPriv(PostResultsVfact)"
	    }
	}
    }
    #set postcmd "$postcmd escape escape escape escape utilities variables"
    #set postcmd "$postcmd AutomaticRedraw $oldAutomaticRedraw escape escape"
    .central.s process $postcmd

    # lo separamos por si lo de arriba da un error
    set postcmd "escape escape escape escape utilities variables"
    set postcmd "$postcmd AutomaticRedraw $oldAutomaticRedraw escape escape"
    .central.s process $postcmd

#    .central.s makecurrent
#    .central.s process redraw"
    .central.s render

#     regsub -all { } $GidPriv(PostResultsDS) {} var
#     if { $var != [ .central.s info post get cur_Results_style] } {
#         .central.s process escape escape escape escape ResultsStyle $var
#     }
#     .central.s process escape escape escape escape utilities variables \
#             AutomaticRedraw $oldAutomaticRedraw escape escape 
#     .central.s process redraw


    set GidPriv(PRDoingAccept) 0
}

proc PRSeleccionResultado { nodo} {
    global GidPriv

    if { $nodo == ""} { return}
    set arbol $GidPriv(Result_wid)
    set datos [ $arbol itemcget $nodo -data]
    if { $::PRDebug} {
	WarnWinText "$nodo - [ $arbol itemcget $nodo -data]"
    }
    if { "[ lindex $datos 0]" == "hoja"} {
	set res_name [ lindex $datos 1]
	set res_comp [ lindex $datos 2]
	$arbol selection set $nodo
	regsub -all {_} $res_name { } txt
	if { $::PRDebug} {
	    #WarnWin $txt
	    WarnWinText "$txt - $res_name - $res_comp"
	}
	set GidPriv(Result_actualizar) 0
	set GidPriv(PostResultsRes) "$txt"
	set GidPriv(PostResultsComp) "$res_comp"
	set GidPriv(Result_actualizar) 1
    } else {
	if { [ $arbol itemcget $nodo -open] } {
	    $arbol closetree $nodo
	} else {
	    for { set p $nodo} { "$p" != "root"} { set p [ $arbol parent $p]} {
		$arbol opentree $p
	    }
	}
    }
    $arbol see $nodo
}

proc PRDoApply { nodo} {
    global GidPriv
    if { $nodo == ""} { return}
    set arbol $GidPriv(Result_wid)
    set datos [ $arbol itemcget $nodo -data]
    if { $::PRDebug} {
	WarnWinText "$nodo - [ $arbol itemcget $nodo -data]"
    }
    if { "[ lindex $datos 0]" == "hoja"} {
	PRAccept
    }
}

#proc PRAbrirCerrarArbol { nodo} {
#    global GidPriv
#
#    set arbol $GidPriv(Result_wid)
#    if { [ $arbol itemcget $nodo -open] } {
#         $arbol closetree $nodo
#    } else {
#         for { set p $nodo} { "$p" != "root"} { set p [ $arbol parent $p]} {
#             $arbol opentree $p
#         }
#    }
#}

proc PostResultsDeleteTraceVariables { w_evento w_padre} {
    if { $w_evento == $w_padre} {
	trace vdelete ::GidPriv(PostResultsAnal) w FillPRSteps
	####trace vdelete ::GidPriv(PostResultsStep) w PRChangedEntry
	trace vdelete ::GidPriv(PostResultsStep) w PRChangedStep
	trace vdelete ::GidPriv(PostResultsView) w FillPROtherMenus
	trace vdelete ::GidPriv(PostResultsRes) w FillPROtherMenus
	trace vdelete ::GidPriv(PostResultsComp) w FillPROtherMenus
	if { $::PRDebug} {
	    WarnWinText "PRDeleteTraceVariables"
	}
    }
}

proc PostResultsSetTraceVariables { } {
    trace variable ::GidPriv(PostResultsAnal) w FillPRSteps
    ####trace variable ::GidPriv(PostResultsStep) w PRChangedEntry
    trace variable ::GidPriv(PostResultsStep) w PRChangedStep
    trace variable ::GidPriv(PostResultsView) w FillPROtherMenus
    trace variable ::GidPriv(PostResultsRes) w FillPROtherMenus
    trace variable ::GidPriv(PostResultsComp) w FillPROtherMenus
    if { $::PRDebug} {
	WarnWinText "PRSetTraceVariables"
    }
}


proc PostResultsSetResultsView { nueva_vista} {
    global GidPriv
    if { "$nueva_vista" != ""} {    
	regsub -all {_} $nueva_vista { } txt
	set GidPriv(PostResultsView) [_ $txt]
    }
}

proc PostResults { { w .gid.wPostResults } { inside 0} } {
    global GidPriv

    #puts PostResults----------------------------
    if { !$inside} {
	InitWindow $w [_ "View Results"] PostResultsWindowGeom PostResults
	if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    } else {
	set GidPriv(PostResultsWindow) $w
    }

    PostResultsDeleteTraceVariables $w $w

    set color_fondo [ CCGetRGB $w [ $w cget -background]]
    set color_sel [ CCColorSombra $color_fondo 65]

    if { !$inside} {
	frame $w.rv -relief ridge -bd 2
    } else {
	frame $w.rv -bd 0
    }

    label $w.rv.l2 -text [_ "View:"]
    ComboBox $w.rv.m2 -textvariable GidPriv(PostResultsView) -editable 0 -width 20 -bd 1

    label $w.rv.l1 -text [_ "Analysis:"]
    ComboBox $w.rv.m1 -textvariable GidPriv(PostResultsAnal) -editable 0 -width 20 -bd 1

    label $w.rv.lstep -text [_ "Step:"]
    ComboBox $w.rv.cbstep -textvariable GidPriv(PostResultsStep) -editable 0 -width 8 -bd 1
    
    label $w.rv.lres -text [_ "Results:"]
 
    set sw1 [ ScrolledWindow $w.rv.rtsw -relief sunken -bd 1 -auto both]
    set tree1 [ Tree $sw1.tree -relief flat -borderwidth 0 \
	    -highlightthickness 0 -selectbackground "darkblue" \
	    -highlightbackground yellow -width 30 -redraw 1]

    set GidPriv(Result_wid) $tree1
    set GidPriv(Result_actualizar) 1

    $tree1 bindImage <Control-1> {}
    $tree1 bindText <Control-1> {}
    $tree1 bindImage <1> PRSeleccionResultado
    $tree1 bindText <1> PRSeleccionResultado
    $tree1 bindText <Double-Button-1> PRDoApply

    $sw1 setwidget $tree1


    combobox $w.rv.m3 -textvariable GidPriv(PostResultsRes) -editable 0

    label $w.rv.l5 -text [_ "Component:"]
    set menu [ tk_optionMenuRAM $w.rv.m4 GidPriv(PostResultsComp) "" ""]
    $w.rv.m4 configure -width 20 -bd 1 -highlightthickness 1
    $menu configure -bd 1 -activeborderwidth 1

    frame $w.rv.f
    label $w.rv.f.l6 -text [_ "factor:"]
    entry $w.rv.f.e2 -relief sunken -width 12 -textvariable GidPriv(PostResultsVfact) -bd 1
    pack $w.rv.f.l6 $w.rv.f.e2 -side left   

    if { !$inside} {
	frame $w.but -bd 0 -background [ CCColorActivo $color_fondo]
	button $w.but.accept -text [_ "Apply"] -command PRAccept -takefocus 0 -bd 1
	button $w.but.close -text [_ "Close"] -command "destroy $w" -takefocus 0 -bd 1
	SetWidgetsWidthFromText $w.but.accept $w.but.close
	grid $w.but.accept $w.but.close -pady 6 -padx 5 -sticky ews
    }
    bind $w <Destroy> "+ PostResultsDeleteTraceVariables %W $w"

    grid $w.rv.l2 -sticky e -row 0 -column 0 -padx 2 -pady 1
    grid $w.rv.m2 -sticky w -row 0 -column 1 -padx 2 -pady 1
    grid $w.rv.l1 -sticky e -row 1 -column 0 -padx 2 -pady 1
    grid $w.rv.m1 -sticky w -row 1 -column 1 -padx 2 -pady 1
    grid $w.rv.lstep -sticky w -row 0 -column 2 -padx 2 -pady 1
    grid $w.rv.cbstep -sticky e -row 1 -column 2 -padx 2 -pady 1
    grid $sw1 -sticky news -row 2 -column 0 -columnspan 3 -padx 2 -pady 1
    grid $w.rv.f -sticky w -row 4 -column 0 -columnspan 3 -padx 2 -pady 1
    grid columnconfigure $w.rv 1 -weight 1
    grid rowconfigure $w.rv 2 -weight 1

    if { !$inside} {
	grid $w.rv -sticky nsew
	grid $w.but -sticky sew
    } else {
	grid $w.rv -sticky nsew -padx 4 -pady 8
    }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
 

    FillPRInfo

    if { !$inside} {
	#bind $w <Return> "tkButtonInvoke $w.but.accept"
	bind $w <Alt-c> "tkButtonInvoke $w.but.close"
	bind $w <Escape> "tkButtonInvoke $w.but.close"
    }

    PostResultsSetTraceVariables
}


#----------------------SetCoord ALONE---------------------------
# if { $PRRunningAlone == 1 } {
#     PostResults .wPostPR
# } 
#-----------------------------------------------------------------

proc FillPostLegendInfo { } {
    global GIDDEFAULT PLegendPriv GidPriv

    if { ![ info exist GidPriv(PostLegendWindow)] || ![ winfo exist $GidPriv(PostLegendWindow)]} {
	return
    }
    set w $GidPriv(PostLegendWindow)
    #$PLegendPriv(w)

    set lst_colores [ .central.s info post get current_color_scale]
	
    set lst_info [ .central.s info post get info_leyenda]

    if { ( "$lst_colores" == "") || ( "$lst_info" == "")} {
	$PLegendPriv(CanvasLabel) configure -text {}
	$PLegendPriv(Canvas) del all
	return
    }

    #WarnWin $lst_info

    set cv $PLegendPriv(Canvas)

    $PLegendPriv(CanvasLabel) configure -text {}
    $cv del all

    set que_res [ lindex $lst_info 0]

    if { ( "$que_res" == "") || ( "$que_res" == "NOTHING")} {
	$PLegendPriv(CanvasLabel) configure -text {}
	$PLegendPriv(Canvas) del all
	return
    }

    if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL") || \
	    ( "$que_res" == "CONTOUR_LINES") || ( "$que_res" == "CONTOUR_RANGES") || \
	    ( "$que_res" == "VECTORS") || ( "$que_res" == "ISO_SURFACES") } {
	#set label_txt [ lindex $lst_info 1]
	regsub -all {_} [ lindex $lst_info 1] { } label_txt
	$PLegendPriv(CanvasLabel) configure -text $label_txt
	
	if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL")} {
	    set n_info [ expr [ lindex $lst_info 2] + 1]
	} else {
	    set n_info [ lindex $lst_info 2]
	}
	set entradas [ lindex $lst_info 3]
	
	set n_col [ lindex $lst_colores 0]
	if {  ( $n_col > 0) && ( $n_info > 0)} {
	    # ajustamos parametros escala de color
	    set margen_h 12.0
	    set margen_w 8.0 
	    set max_v [ expr $PLegendPriv(CanvasHeight) - 2.0 * $margen_h]
	    set incr_col 1.0
	    
	    if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL") || \
		    ( "$que_res" == "ISO_SURFACES") || ( "$que_res" == "CONTOUR_RANGES")} {
		set npix [ expr $max_v / $n_col]
	    } else {
		set npix [ expr $max_v / [ expr $n_col - 1]]
	    }
	    if { $npix < 1.0} {
		set npix 1.0
		if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL") || \
		        ( "$que_res" == "ISO_SURFACES") || ( "$que_res" == "CONTOUR_RANGES")} {
		    set incr_col [ expr $n_col / $max_v]
		} else {
		    set incr_col [ expr [ expr $n_col - 1] / $max_v]
		}
	    }

	    set xi $margen_w
	    set xo [ expr $xi + 16.0]
	    set yi $margen_h
	    if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL") || \
		    ( "$que_res" == "ISO_SURFACES") || ( "$que_res" == "CONTOUR_RANGES")} {
		set yo [ expr $yi + $npix]
	    } else {
		set yo $yi
	    }

	    if { ( "$que_res" != "CONTOUR_RANGES")} {
		set alto_linea [ font metrics FixedFont -linespace]
		set num_lin [ expr round( $max_v / $alto_linea)]
	    } else {
		set num_lin $n_info
	    }
	    if { $num_lin < 1.0} { set num_lin 1.0}
	    #ajustamos parametros entradas de texto
	    set incr_idx_txt 1.0
	    if { $n_info > [ expr $num_lin + 1]} {
		if { $num_lin < 2.0} { set num_lin 2.0}
		set incr_idx_txt [ expr ( $n_info - 1.0) / ( $num_lin - 1.0)]
		set n_txt [ expr $num_lin - 1]
		set tmp ""
		lappend tmp [ format %.5g [ lindex $entradas 0]]
		set div [ expr ( [ lindex $entradas [ expr $n_info - 1]] - [ lindex $entradas 0]) / ( $num_lin - 1.0)]
		for { set i 1} { $i < $n_txt} { incr i} {
		    lappend tmp [ format %.5g [ expr [ lindex $tmp [ expr $i - 1]] + $div]]
		}
		lappend tmp [ format %.5g [ lindex $entradas [ expr $n_info - 1]]]
		set entradas $tmp
		#WarnWin "[ llength $entradas] - $entradas"
	    } else {
		#WarnWin "$n_info - $entradas"
		set n_txt [ expr $n_info - 1]
		if { ( "$que_res" != "CONTOUR_RANGES")} {
		    set tmp ""
		    for { set i 0} { $i <= $n_txt} { incr i} {
		        lappend tmp [ format %.5g [ lindex $entradas $i]]
		    }
		    set entradas $tmp
		}
	    }

	    # chapuza para alinear for la izquierda
	    set ll 0
	    set px 0.0
	    foreach i $entradas {
		set il [ string length $i]
		if { $il > $ll} { set ll $il}
		set ix [ font measure FixedFont $i]
		if { $ix > $px} { set px $ix}
	    }
	    set tmp ""
	    foreach i $entradas {
		lappend tmp [ format %-${ll}s $i]
	    }
	    set entradas $tmp

	    if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL") || \
		    ( "$que_res" == "CONTOUR_LINES") || ( "$que_res" == "VECTORS")} {
		set ntpix [ expr $max_v / $n_txt]
	    } else {
		set ntpix [ expr $max_v / ( $n_txt + 1.0)]
	    }
	    set txi_linea $xo
	    set txo_linea [ expr $txi_linea + 4.0]
	    # fallo del canvas, el texto lo alinea centrado, ponga lo que se ponga
	    #set txi_texto [ expr $txo_linea + 4.0]
	    #set txi_texto [ expr ( $PLegendPriv(CanvasWidth) - $txo_linea) / 3.0 + $txo_linea]
	    set txi_texto [ expr $txo_linea + 2.0 + $px / 2.0]
	    set tyi_linea $yi
	    set tyo_linea $yi
	    # como es centered, no hace falta esto:
	    #set tyi_texto [ expr $yi + 3.0]
	    if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL") || \
		    ( "$que_res" == "CONTOUR_LINES") || ( "$que_res" == "VECTORS") } {
		set tyi_texto $yi
	    } else {
		set tyi_texto [ expr $yi + $ntpix * 0.5] 
	    }


	    set x_sep [ expr $PLegendPriv(CanvasWidth) / 3.0]
	    $cv create line [ expr round( $x_sep)] 1 [ expr round( $x_sep + $x_sep)] 1 -fill black
	    if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL") || \
		    ( "$que_res" == "CONTOUR_RANGES") || ( "$que_res" == "ISO_SURFACES")} {
		for { set i 1.0} { [ expr round( $i)] <= $n_col} { set i [ expr $i + $incr_col]} {
		    $cv create rectangle [ expr round( $xi)] [ expr $PLegendPriv(CanvasHeight) - round( $yi)] \
		            [ expr round( $xo)] [ expr $PLegendPriv(CanvasHeight) - round( $yo)] \
		            -fill [ lindex $lst_colores [ expr round( $i)]] -outline ""
		    set yi [ expr $yi + $npix]
		    set yo [ expr $yo + $npix]
		}
	    } else {
		for { set i 1.0} { [ expr round( $i)] <= $n_col} { set i [ expr $i + $incr_col]} {
		    $cv create line [ expr round( $xi)] [ expr $PLegendPriv(CanvasHeight) - round( $yi)] \
		            [ expr round( $xo)] [ expr $PLegendPriv(CanvasHeight) - round( $yo)] \
		            -fill [ lindex $lst_colores [ expr round( $i)]]
		    set yi [ expr $yi + $npix]
		    set yo [ expr $yo + $npix]
		}
	    }

	    #set itexto 0.0
	    for { set i 0} { $i <= $n_txt} { incr i} {
		#WarnWin "$i - $itexto - $n_txt"
		if { ( "$que_res" == "CONTOUR_FILL") || ( "$que_res" == "SMOOTH_CONTOUR_FILL") } {
		    $cv create line [ expr round( $txi_linea)] \
		            [ expr $PLegendPriv(CanvasHeight) - round( $tyi_linea)] \
		            [ expr round( $txo_linea)] \
		            [ expr $PLegendPriv(CanvasHeight) - round( $tyo_linea)] -fill black
		}
		$cv create text [ expr round( $txi_texto)] \
		        [ expr $PLegendPriv(CanvasHeight) - round( $tyi_texto)] \
		        -fill black -text [ lindex $entradas $i] -font FixedFont
		#[ lindex $entradas [ expr round( $itexto)]]
		set tyi_linea [ expr $tyi_linea + $ntpix]
		set tyo_linea [ expr $tyo_linea + $ntpix]
		set tyi_texto [ expr $tyi_texto + $ntpix]
		#set itexto [ expr $itexto + $incr_idx_txt]
	    }
	}
    } else {
	# no es contour_fill ni contour_lines ni iso_surfaces
	if { "$que_res" == "LOCAL_AXES"} {
	    set label_txt [ lindex $lst_info 1]
	    $PLegendPriv(CanvasLabel) configure -text $label_txt

	    if { ![ info exists PLegendPriv(ImagenEjesLocales)]} {
		set PLegendPriv(ImagenEjesLocales) [ image create photo -file $GIDDEFAULT/bitmaps/localaxes.gif]
	    }

	    $cv create image [ expr $PLegendPriv(CanvasWidth) / 2] [ expr $PLegendPriv(CanvasHeight) / 2]\
		    -anchor center -image $PLegendPriv(ImagenEjesLocales)
	}
    }
    
}

proc PostLegendResizeCanvas { width height } {
    global GIDDEFAULT PLegendPriv GidPriv

    set PLegendPriv(CanvasWidth) [ expr $width - 10]
    set PLegendPriv(CanvasHeight) [ expr $height - 10 - [ winfo reqheight $PLegendPriv(CanvasLabel)] - 4]
    $PLegendPriv(Canvas) configure -width $PLegendPriv(CanvasWidth) -height $PLegendPriv(CanvasHeight)

    FillPostLegendInfo
}

proc ExistPostLegend { } {
    global PLegendPriv
    set ret 0
    if { [ info exists PLegendPriv(window)] && [ winfo exists $PLegendPriv(window)]} {
	set ret 1
    } else {
	set ret 0
    }
    return $ret
}

proc PostLegendInside { } {
    global PLegendPriv

    .central.s process escape escape escape escape Hardcopy Options ShowLegends yes
    destroy $PLegendPriv(window)
}

proc PostLegend { { w .gid.wPostLegend } } {
    global GIDDEFAULT PLegendPriv

    set PLegendPriv(window) $w

    InitWindow $w [_ "Legend"] PostLegendWindowGeom PostLegend
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    wm minsize $w 160 110

    frame $w.f1 -relief ridge -bd 2
    label $w.f1.l 

    canvas $w.f1.c -width 128 -height 200
    set PLegendPriv(CanvasWidth) 128
    set PLegendPriv(CanvasHeight) 200
    grid $w.f1.l -sticky ew -padx 4 -pady 2
    grid $w.f1.c -sticky news -padx 2 -pady 2
    set PLegendPriv(Canvas) $w.f1.c
    set PLegendPriv(CanvasLabel) $w.f1.l

    frame $w.but
    # button $w.but.accept -text [_ "Accept"] -bd 1 -command PostPointAccept
    # button $w.but.original -text [_ "Original"] -bd 1 -command PostPointOriginal
    button $w.but.inside -text [_ "Inside"] -bd 1 -command PostLegendInside
    button $w.but.close -text [_ "Close"] -bd 1 -command "destroy $w"
    SetWidgetsWidthFromText $w.but.inside $w.but.close 

    # grid $w.but.accept -padx 4 -pady 2 -sticky ew
    # grid $w.but.original -padx 4 -pady 2 -sticky ew
    grid $w.but.inside $w.but.close -padx 4 -pady 2 -sticky ew

    grid $w.f1 -sticky nsew -padx 3 -pady 3
    grid $w.but -sticky nsew -padx 3 -pady 3
# -column 2 -row 0 
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    update
    set width [ winfo reqwidth $w.f1]
    set height [ winfo reqheight $w.f1]
    set PLegendPriv(CanvasWidth) [ expr $width - 10]
    set PLegendPriv(CanvasHeight) [ expr $height - 20 - [ winfo reqheight $PLegendPriv(CanvasLabel)] - 4]
    $PLegendPriv(Canvas) configure -width $PLegendPriv(CanvasWidth) -height $PLegendPriv(CanvasHeight)
    update idletasks

    bind $w.f1 <Configure> "PostLegendResizeCanvas %w %h"
    FillPostLegendInfo

    .central.s process escape escape escape escape Hardcopy Options ShowLegends no

}








